
-- Adopt from Garan's Anthology Plugin
FontMetric = class(Turbine.UI.Control);

-- Initializes a new FontMetric instance
function FontMetric:Constructor(font)
	Turbine.UI.Control.Constructor(self);

	self.FontHeight = math.max(1, Fonts.GetFontHeight(font));

	local control = Turbine.UI.Label();
	control:SetParent(self);
	control:SetMultiline(true);
	control:SetFont(font);

	self.Label = control;

	local control = Turbine.UI.Lotro.ScrollBar();
	control:SetParent(self);
	control:SetOrientation(Turbine.UI.Orientation.Vertical);

	self.VerticalScrollbar = control;
	self.Label:SetVerticalScrollBar(self.VerticalScrollbar);
end

-- Calculates the required text height boundary
function FontMetric:GetTextHeight(text, width)
	self.Label:SetWidth(width)
	self.Label:SetText(text);
	self.Label:SetHeight(self.FontHeight);

	local minValue = self.FontHeight;
	local maxValue = self.FontHeight;
	local midValue = self.FontHeight;

	while self.VerticalScrollbar:IsVisible() do
		minValue = self.Label:GetHeight();
		maxValue = minValue * 2;
		midValue = math.ceil((minValue + maxValue) * 0.5);
		self.Label:SetHeight(midValue);
	end

	while midValue < maxValue do
		if self.VerticalScrollbar:IsVisible() then
			minValue = midValue;
			midValue = math.ceil((minValue + maxValue) * 0.5);
		else
			maxValue = midValue;
			midValue = math.floor((minValue + maxValue) * 0.5);
		end

		self.Label:SetHeight(midValue);
	end
	
	if self.VerticalScrollbar:IsVisible() then
		Turbine.Shell.WriteLine("label vertical scrollbar is still visible");
	end

	return midValue;
end
